Botan 2.1.0 Crypto and TLS for C++11

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | List of all members
Botan::PK_Ops::KEM_Decryption_with_KDF Class Referenceabstract

`#include <pk_ops_impl.h>`

Inheritance diagram for Botan::PK_Ops::KEM_Decryption_with_KDF:

## Public Member Functions
secure_vector< uint8_t > | kem_decrypt (const uint8_t encap_key[], size_t len, size_t desired_shared_key_len, const uint8_t salt[], size_t salt_len) override

## Protected Member Functions
| KEM_Decryption_with_KDF (const std::string &kdf)
virtual secure_vector< uint8_t > | raw_kem_decrypt (const uint8_t encap_key[], size_t len)=0
| ~KEM_Decryption_with_KDF ()=default

## Detailed Description

Definition at line 206 of file pk_ops_impl.h.

## Constructor & Destructor Documentation

Botan::PK_Ops::KEM_Decryption_with_KDF::KEM_Decryption_with_KDF | ( | const std::string & | kdf | ) |
| explicit protected

Definition at line 167 of file pk_ops.cpp.

References Botan::get_kdf().

168 {
169 m_kdf.reset(get_kdf(kdf));
170 }
Botan::get_kdf
KDF * get_kdf(const std::string &algo_spec)
Definition: kdf.cpp:226

Botan::PK_Ops::KEM_Decryption_with_KDF::~KEM_Decryption_with_KDF | ( |  | ) |
| protected default

## Member Function Documentation

secure_vector< uint8_t > Botan::PK_Ops::KEM_Decryption_with_KDF::kem_decrypt | ( | const uint8_t | encap_key[],
|  | size_t | len,
|  | size_t | desired_shared_key_len,
|  | const uint8_t | salt[],
|  | size_t | salt_len
| ) |  |
| override virtual

Implements Botan::PK_Ops::KEM_Decryption.

Definition at line 154 of file pk_ops.cpp.

159 {
160 secure_vector<uint8_t> raw_shared = this->raw_kem_decrypt(encap_key, len);
161
162 return m_kdf->derive_key(desired_shared_key_len,
163 raw_shared.data(), raw_shared.size(),
164 salt, salt_len);
165 }
Botan::PK_Ops::KEM_Decryption_with_KDF::raw_kem_decrypt
virtual secure_vector< uint8_t > raw_kem_decrypt(const uint8_t encap_key[], size_t len)=0

virtual secure_vector<uint8_t> Botan::PK_Ops::KEM_Decryption_with_KDF::raw_kem_decrypt | ( | const uint8_t | encap_key[],
|  | size_t | len
| ) |  |
| protected pure virtual

The documentation for this class was generated from the following files:

- src/lib/pubkey/pk_ops_impl.h
- src/lib/pubkey/pk_ops.cpp